<html>
<head>
<title>OgreGLSLESCgProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_869fcd4d0767bf0c6544e0566078ca07.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_9c8668f5b14e7779923b4ed363e11a4e.html">GLSLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_84d626bd39fc7a71e1d66527f3ce1f64.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLESCgProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLESCgProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLSLESCgProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLESCgProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSLESProgram_8h.html">OgreGLSLESProgram.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html">00039</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLSLESCgProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for CG.">GLSLESCgProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLSLESProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgram</a>
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041     <span class="keyword">public</span>:
<a name="l00043"></a><a class="code" href="classOgre_1_1GLSLESCgProgram_1_1CmdProfiles.html">00043</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1GLSLESCgProgram_1_1CmdProfiles.html" title="Command object for setting profiles.">CmdProfiles</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00044"></a>00044         {
<a name="l00045"></a>00045         <span class="keyword">public</span>:
<a name="l00046"></a>00046             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00047"></a>00047             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00048"></a>00048         };
<a name="l00050"></a><a class="code" href="classOgre_1_1GLSLESCgProgram_1_1CmdEntryPoint.html">00050</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1GLSLESCgProgram_1_1CmdEntryPoint.html" title="Command object for setting entry point.">CmdEntryPoint</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00051"></a>00051         {
<a name="l00052"></a>00052         <span class="keyword">public</span>:
<a name="l00053"></a>00053             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00054"></a>00054             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00055"></a>00055         };
<a name="l00056"></a>00056 
<a name="l00057"></a>00057         <a class="code" href="classOgre_1_1GLSLESCgProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for CG.">GLSLESCgProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, 
<a name="l00058"></a>00058             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00059"></a>00059             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00060"></a>00060         ~<a class="code" href="classOgre_1_1GLSLESCgProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for CG.">GLSLESCgProgram</a>();
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00064"></a>00064         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00065"></a>00065 
<a name="l00067"></a>00067         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getLanguage(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00068"></a>00068 
<a name="l00070"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html#a0db1b22e3a2bfd0fae381aae3cf08711">00070</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLSLESCgProgram.html#a0db1b22e3a2bfd0fae381aae3cf08711" title="Sets the entry point for this program ie the first method called.">setEntryPoint</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; entryPoint) { mEntryPoint = entryPoint; }
<a name="l00072"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html#ae6983705a21781f5a722c373ba56d93a">00072</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GLSLESCgProgram.html#ae6983705a21781f5a722c373ba56d93a" title="Gets the entry point defined for this program.">getEntryPoint</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mEntryPoint; }
<a name="l00074"></a>00074         <span class="keywordtype">void</span> setProfiles(<span class="keyword">const</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; profiles);
<a name="l00076"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html#acb1e79e7f7f1d4ec858ce101d5cd17de">00076</a>         <span class="keyword">const</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; <a class="code" href="classOgre_1_1GLSLESCgProgram.html#acb1e79e7f7f1d4ec858ce101d5cd17de" title="Gets the Cg profiles which can be supported by the program.">getProfiles</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mProfiles; }
<a name="l00077"></a>00077     <span class="keyword">protected</span>:
<a name="l00078"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html#a8b318fd965416bd0806245c54414fdf6">00078</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLESCgProgram_1_1CmdEntryPoint.html" title="Command object for setting entry point.">CmdEntryPoint</a> <a class="code" href="classOgre_1_1GLSLESCgProgram.html#a8b318fd965416bd0806245c54414fdf6">msCmdEntryPoint</a>;
<a name="l00079"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html#ac620395870e010509c2a02bc3cd83b96">00079</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLESCgProgram_1_1CmdProfiles.html" title="Command object for setting profiles.">CmdProfiles</a> <a class="code" href="classOgre_1_1GLSLESCgProgram.html#ac620395870e010509c2a02bc3cd83b96">msCmdProfiles</a>;
<a name="l00080"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html#a2ae1f98002687ae6e0d253730da13fde">00080</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLSLESCgProgram.html#a2ae1f98002687ae6e0d253730da13fde">mEntryPoint</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1GLSLESCgProgram.html#a5e45709b371df7b517bdda72a6003c09">00081</a>         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="code" href="classOgre_1_1GLSLESCgProgram.html#a5e45709b371df7b517bdda72a6003c09">mProfiles</a>;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         <span class="comment">// check if syntax is supported</span>
<a name="l00084"></a>00084         <span class="keywordtype">bool</span> isSyntaxSupported();
<a name="l00086"></a>00086         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> resolveCgIncludes(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource, <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* resourceBeingLoaded, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; fileName);
<a name="l00087"></a>00087         <span class="comment">// deletes the key word &quot;: register(xx)&quot; that hlsl2glsl doesn&#39;t know to handle</span>
<a name="l00088"></a>00088         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> deleteRegisterFromCg(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; inSource);
<a name="l00089"></a>00089     };
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="preprocessor">#endif // __GLSLESCgProgram_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
